$Option EXPLICIT
$Include "RapidQ.inc"

Declare Sub MainForm_OnShow : Declare Sub MainForm_OnClose : Declare Sub tCanvas_OnPaint
Declare Sub gCanvas_OnPaint(Sender As QCanvas) : Declare Sub mBack_OnClick
Declare Sub gCanvas_OnMouseDown(B As Integer, X As Integer, Y As Integer, S As Integer, Sender As QCanvas)
Declare Sub gCanvas_OnMouseMove(X As Integer, Y As Integer, S As Integer)
Declare Sub gCanvas_OnMouseUp(B As Integer, X As Integer, Y As Integer, S As Integer, Sender As QCanvas)
Declare Sub Canvas_OnPaint : Declare Sub Maatje (Sender as QButton)
Declare Sub Canvas_OnMouseDown(B As Integer, X As Integer, Y As Integer, S As Integer)
Declare Sub mOpen_OnClick : Declare Sub mSave_OnClick : Declare Sub mClear_OnClick : Declare Sub mExplain_OnClick
Declare Sub mSize_OnClick : Declare Sub mKlep_OnClick : Declare Sub klep (Sender as QCoolBtn)

$resource T0 as "Lucht.BMP" : $resource T1 as "Vloer.BMP" : $resource T2 as "Kist.BMP" : $resource T3 as "Vert.BMP"
$resource T4 as "Hori.BMP" : $resource T5 as "Muur.BMP" : $resource T6 as "Doel.BMP" : $resource T7 as "Plak.BMP"
$resource T8 as "Verm.BMP" : $resource T9 as "Horm.BMP"

dim pltjs(9) as Qimage
  pltjs(1).BMPhandle=T1 : pltjs(2).BMPhandle=T2 : pltjs(3).BMPhandle=T3 : pltjs(4).BMPhandle=T4 : pltjs(5).BMPhandle=T5
  pltjs(6).BMPhandle=T6 : pltjs(0).BMPhandle=T0 : pltjs(7).BMPhandle=T7 : pltjs(8).BMPhandle=T8 : pltjs(9).BMPhandle=T9

Dim ImgIdx As Integer
DefInt xx, yy, dx, dy, dc, cx, cy, cc, px, py, mx, my, bx, by, x, y, a, b, lx, ly
DefInt h, v, kl, p, n, m, l, pp, q, t, wit, fout, man, krat, doel
DefStr a$, f$, fi$, fl$, pl$, fout$, pg$, dt$, bl$, hak$

px=14 : mx=19 : bx=px*mx+4 : lx=int((screen.width-175)/17) : if lx>110 then lx=110
py=14 : my=19 : by=py*my+4 : ly=int((screen.height-100)/17) : if ly>110 then ly=110
pp=bx : wit=&hffffff : f$="unnamed" : bl$=curdir$

Dim gStr(12) As String
    gStr(0)  = Chr$(218) : gStr(1)  = Chr$(191) : gStr(2)  = Chr$(192) : gStr(3)  = Chr$(217)
    gStr(4)  = Chr$(193) : gStr(5)  = Chr$(194) : gStr(6)  = Chr$(195) : gStr(7)  = Chr$(180)
    gStr(8)  = Chr$(179) : gStr(9)  = Chr$(196) : gStr(10) = Chr$(197) : gStr(11) = Chr$(32)

Dim OpenDialog As QOpenDialog
    OpenDialog.Filter = "SokoBan plan    [*.SBL]|*.SBL"
    OpenDialog.InitialDir = curdir$

Dim SaveDialog As QSaveDialog
    SaveDialog.Filter = "SokoBan plan    [*.SBL]|*.SBL"
    SaveDialog.InitialDir = curdir$

Create MainForm As QForm
  DelBorderIcons(biMaximize, biMinimize) : BorderStyle = bsSingle : Caption = " Sokoban  la Rapid Q            level design tool"
  ClientWidth  = 350 : ClientHeight  = 300 : Center : OnShow  = MainForm_OnShow : OnClose = MainForm_OnClose
  Create MainMenu As QMainMenu
    Create mOpen As QMenuItem
      Caption = " Load "
      OnClick = mOpen_OnClick
    End Create
    Create mLine1 As QMenuItem
      Enabled = False
      Caption = " | "
    End Create
    Create mSave As QMenuItem
      Caption = " Save "
      OnClick = mSave_OnClick
    End Create
    Create mLine2 As QMenuItem
      Enabled = False
      Caption = " | "
    End Create
    Create mClear As QMenuItem
      Caption = " Base level "
      OnClick = mClear_OnClick
    End Create
    Create mLine3 As QMenuItem
      Enabled = False
      Caption = " | "
    End Create
    Create mExplain as QMenuItem
      Caption = " Manual "
      OnClick = mExplain_OnClick
    End Create
    Create mLine4 As QMenuItem
      Enabled = False
      Caption = " | "
    End Create
    Create mBack as QMenuItem
      Caption = " Redraw "
      OnClick = mBack_OnClick
    End Create
  End Create
  Create Canvas As QCanvas
    Left = 5 : Top = 5 : Width = bx : Height = by
    OnPaint = Canvas_OnPaint : OnMouseDown = Canvas_OnMouseDown
  End Create
  Create tCanvas As QCanvas
    Left = 256 : Top = 190 : Width = px : Height = py
    OnPaint = tCanvas_OnPaint : Visible = False
  End Create : '  'This is the canvas that's actually getting dragged.
End Create

Dim gPanel(10) As QPanel : Dim gCanvas(10) As QCanvas : Dim gBMP(10) As QBitmap
Dim BluePrint as QStringGrid
  BluePrint.ColCount=14 :  BluePrint.RowCount=14 : BluePrint.Separator = "*"
  for a=0 to 14 : for b=0 to 14 : BluePrint.Cell(a,b)="" : next b : next a

Dim ImgBuf As QBitmap
    ImgBuf.Width = bx : ImgBuf.Height = by : ImgBuf.PixelFormat = pf32bit
    ImgBuf.FillRect(0, 0, ImgBuf.Width, ImgBuf.Height, &hffffff)
    ImgBuf.Rectangle(0, 0, ImgBuf.Width, ImgBuf.Height,0)

DIM Panel AS QPANEL
    Panel.Parent = MainForm : Panel.Left = 225 : Panel.Top = 3
    Panel.Width = 116 : Panel.Height = 307 : Panel.Visible = 0

dim RiEd as QRichEdit
  RiEd.parent=MainForm : RiEd.plaintext = 1 : RiEd.Visible=0 
  
mClear_OnClick
MainForm.ShowModal

Sub MainForm_OnShow
  Dim i As Integer : Dim x As Integer : Dim y As Integer
  for y=0 to 9
    i=y : px=19 : py=19 : l=18+pp : t=y*32+15 : if y>5 then l=l+32 : t=t-160
    gPanel(i).Left = l : gPanel(i).Top= t : gPanel(i).Width = px+4 : gPanel(i).Height = py+4 : gPanel(i).Parent = MainForm
    gPanel(i).Color  = &h909090 : gBMP(i).Width  = px : gBMP(i).Height = py : gBMP(i).BMP=pltjs(y).bmp
    gCanvas(i).Width = px : gCanvas(i).Height =  py : gCanvas(i).Parent = gPanel(i) : gCanvas(i).Left = 2 : gCanvas(i).Top = 2
    gCanvas(i).Tag = i : gCanvas(i).OnPaint = gCanvas_OnPaint : gCanvas(i).OnMouseDown = gCanvas_OnMouseDown
    gCanvas(i).OnMouseMove = gCanvas_OnMouseMove : gCanvas(i).OnMouseUp = gCanvas_OnMouseUp
  next y
End Sub

Sub MainForm_OnClose
    Application.Terminate
End Sub

Sub tCanvas_OnPaint
  tCanvas.Draw(0,0,gBMP(ImgIdx).BMP)
End Sub

Sub gCanvas_OnPaint(Sender As QCanvas)
    Sender.Draw(0, 0, gBMP(Sender.Tag).BMP)
End Sub

Sub gCanvas_OnMouseDown(B As Integer, X As Integer, Y As Integer, S As Integer, Sender As QCanvas)
    ImgIdx = Sender.Tag
    dx = gPanel(ImgIdx).Left : dy = gPanel(ImgIdx).Top
    tCanvas.Width = px : tCanvas.Height = py
    tCanvas.Left = dx : tCanvas.Top = dy : tCanvas.Visible = True
    dc = True
End Sub

Sub gCanvas_OnMouseMove(X As Integer, Y As Integer, S As Integer)
    If dc = True Then
      cc = True : cx = X - 6 : cy = Y - 8
      DoEvents
      tCanvas.Left = dx + cx : tCanvas.Top = dy + cy
    End If
End Sub

Sub gCanvas_OnMouseUp(B As Integer, X As Integer, Y As Integer, S As Integer, Sender As QCanvas)
  If cc = True Then
    cc = False : dc = False
    a = (dx + cx) \ px : b = (dy + cy) \ py
    xx = a * px : yy = b * py
    ImgBuf.Draw(xx+2, yy+2, gBMP(ImgIdx).BMP)
    Canvas_OnPaint
  End If : ' dropped images snap to a grid.
  tCanvas.Visible = False
  BluePrint.Cell(a,b)=str$(ImgIdx)
End Sub

Sub Canvas_OnPaint
    Canvas.Draw(0, 0, ImgBuf.BMP)
End Sub

Sub Canvas_OnMouseDown(B As Integer, X As Integer, Y As Integer, S As Integer)
  If B = 1 Then
    a = X\px : b = Y\py
    BluePrint.Cell(a+1,b+1)=""
    xx = a*px + 2: yy = b*py+2
    ImgBuf.FillRect(xx, yy, xx+px, yy+py, &hffffff)
    Canvas_OnPaint
  End If
End Sub

Sub mOpen_OnClick
  If OpenDialog.Execute Then
    x=len(OpenDialog.Filename) : f$=left$(OpenDialog.Filename,x-4)
    f$=f$+".SBL" : BluePrint.LoadFromFile (f$,0,0,14)
    for x=0 to 13 : for y=0 to 13
        q=val(BluePrint.Cell(x,y))
        ImgBuf.draw(x*19+2,y*19+2,pltjs(q).bmp)
    next y : next x
    Canvas_OnPaint : mSave.Enabled = True : Panel.visible=0 : Canvas.visible=1
    MainForm.Caption = " File loaded: "+f$
  End If
End Sub

sub CheckLevel
  man=0 : krat=0 : doel=0 : RiEd.Clear : pg$="data "
  for x=0 to 13
    for y=0 to 13
        q=val(BluePrint.Cell(x,y)) : pg$=pg$+str$(q)
        if y<13 then pg$=pg$+","
        if q=2 or q=7 then krat=krat+1
        if q=3 or q=4 or q=8 or q=9 then man=man+1
        if q>5 then doel=doel+1
    next y
    if x=3 or x=7 or x=11 then
        RiEd.AddStrings pg$ : pg$="data "
    else
        pg$=pg$+", "
    end if
  next x
  if (doel>0 or krat>0) and krat<>doel then fout$=str$(krat)+" crate(s), "+str$(doel)+" target(s): mismatch."+chr$(10) : fout=1
  if doel=0 and krat=0 then fout$="Unplayable level; no crates or targets."+chr$(10) : fout=2
  if man<>1 then fout$=fout$+chr$(10)+"Place ONE warehouse worker."+chr$(10) : fout=3
end sub

Sub mSave_OnClick
  fout$="" : fout=0 : CheckLevel
  if fout=0 then
    If SaveDialog.Execute Then
        If Right$(SaveDialog.Filename, 4) <> ".SBL" Then SaveDialog.Filename = SaveDialog.Filename + ".SBL"
        f$=SaveDialog.Filename : x=len(SaveDialog.Filename) : q=x-5-len(bl$)
        if q>0 then
             BluePrint.SaveToFile (f$,0,0,14) : MainForm.caption="Saved as "+f$
            pl$=left$(f$,x-3)+"BMP" : ImgBuf.SaveToFile(pl$)
            hak$=right$(left$(f$,x-4),q)
            pg$=pg$+hak$+" : ' made on "+date$ : RiEd.AddStrings pg$
            dt$=left$(f$,x-3)+"txt" : RiEd.SaveToFile(dt$)
        else
            fout$="No level name entered!"+chr$(10)+"Level design NOT saved!"
            if MessageDlg(fout$,0,0,0) = 0 then fout=1
        end if
    end If
  else
    fout$=fout$+chr$(10)+"Level design NOT saved!"
    If MessageDlg(fout$,0,0,0) = 0 then fout=1
  end if 
end Sub

Sub mClear_OnClick
 ImgBuf.FillRect(0, 0, ImgBuf.Width, ImgBuf.Height, &h9c362c)
 for x=0 to 13 : for y=0 to 13
    q=1 : if x=0 or y=0 or x=13 or y=13 then q=5
    if x=0 and (y=0 or y=13) or x=13 and (y=0 or y=13) then q=0
    ImgBuf.draw(x*19+2,y*19+2,pltjs(q).bmp)
    BluePrint.Cell(x,y)=str$(q)
 next y : next x
 Canvas_OnPaint : f$="unnamed" : MainForm.Caption = " Sokoban  la Rapid Q            level design tool"
End Sub

Sub mExplain_OnClick
 ImgBuf.FillRect(0, 0, ImgBuf.Width, ImgBuf.Height, wit) : ImgBuf.Rectangle(0, 0, ImgBuf.Width, ImgBuf.Height, 0)
 for y=0 to 5 : ImgBuf.draw(40,y*25+40,pltjs(y).bmp) : next y
 for y=6 to 9 : ImgBuf.draw(200,y*25-85,pltjs(y).bmp) : next y
 ImgBuf.textout(70,42,"'air'    (this acts just like a wall)",0,wit) : ImgBuf.textout(70,67,"floor                with target",0,wit)
 ImgBuf.textout(70,167,"wall",0,wit) : ImgBuf.textout(70,92,"crate                on target",0,wit)
 ImgBuf.textout(70,130,"  the warehouse worker",0,wit) : ImgBuf.textout(30,200,"Place just one warehouse worker in a level.",0,wit)
 ImgBuf.textout(10,230,"The number of (on) targets must match the number",0,wit) : ImgBuf.textout(10,245,"of crates exactly.",0,wit)
 ImgBuf.textout(10,10,"Sokoban  la Rapid Q        A.C. Lockhorst    2010",0,wit)
 Canvas_OnPaint :  MainForm.Caption = " Sokoban  la Rapid Q            level design tool"
End Sub

Sub mSize_OnClick
  a=1-Panel.visible
  if a=0 then
    Canvas.visible=1
    Canvas_OnPaint
  else
    Canvas.visible=0
  end if
  Panel.visible=a
End Sub

Sub mBack_OnClick
  for x=0 to 13 : for y=0 to 13
    q=val(BluePrint.Cell(x,y))
    ImgBuf.draw(x*19+2,y*19+2,pltjs(q).bmp)
  next y : next x
  Canvas_OnPaint
  MainForm.Caption = " Sokoban        [ "+f$+" ]"
end sub